import * as React from 'react';
import { DropdownHeader } from "./DropdownHeader";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Represents a header item in a igc-dropdown list.
*/
export declare class IgrDropdownHeader<P extends IIgrDropdownHeaderProps = IIgrDropdownHeaderProps> extends React.Component<P, {}> {
    protected createImplementation(): DropdownHeader;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): DropdownHeader; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrDropdownHeader;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        id: P["id"];
        class: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
}
export interface IIgrDropdownHeaderProps {
    children?: React.ReactNode;
    id?: string | undefined;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
}
