import * as React from 'react';
import { SelectGroup } from "./SelectGroup";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
import { IgrSelectItem } from "./igr-select-item";
/**

*/
export declare class IgrSelectGroup<P extends IIgrSelectGroupProps = IIgrSelectGroupProps> extends React.Component<P, {}> {
    protected createImplementation(): SelectGroup;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): SelectGroup; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrSelectGroup;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        id: P["id"];
        class: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * All child `igc-select-item`s.
    */
    get items(): IgrSelectItem[];
    set items(v: IgrSelectItem[]);
    /**
     * Whether the group item and all its children are disabled.
    */
    get disabled(): boolean;
    set disabled(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
}
export interface IIgrSelectGroupProps {
    children?: React.ReactNode;
    id?: string | undefined;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * All child `igc-select-item`s.
    */
    items?: IgrSelectItem[];
    /**
     * Whether the group item and all its children are disabled.
    */
    disabled?: boolean | string;
}
